// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: generationmodule/generationmodule.proto

package openfmb.generationmodule;

/**
 * <pre>
 * OpenFMB specialization for control schedule using:  LN: Schedule   Name: FSCH
 * </pre>
 *
 * Protobuf type {@code generationmodule.GenerationControlScheduleFSCH}
 */
public final class GenerationControlScheduleFSCH extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:generationmodule.GenerationControlScheduleFSCH)
    GenerationControlScheduleFSCHOrBuilder {
private static final long serialVersionUID = 0L;
  // Use GenerationControlScheduleFSCH.newBuilder() to construct.
  private GenerationControlScheduleFSCH(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private GenerationControlScheduleFSCH() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new GenerationControlScheduleFSCH();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlScheduleFSCH_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlScheduleFSCH_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.generationmodule.GenerationControlScheduleFSCH.class, openfmb.generationmodule.GenerationControlScheduleFSCH.Builder.class);
  }

  public static final int VALDCSG_FIELD_NUMBER = 1;
  private openfmb.generationmodule.GenerationCSG valDCSG_;
  /**
   * <pre>
   * Discrete value in GenerationCSG type
   * </pre>
   *
   * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the valDCSG field is set.
   */
  @java.lang.Override
  public boolean hasValDCSG() {
    return valDCSG_ != null;
  }
  /**
   * <pre>
   * Discrete value in GenerationCSG type
   * </pre>
   *
   * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The valDCSG.
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationCSG getValDCSG() {
    return valDCSG_ == null ? openfmb.generationmodule.GenerationCSG.getDefaultInstance() : valDCSG_;
  }
  /**
   * <pre>
   * Discrete value in GenerationCSG type
   * </pre>
   *
   * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.generationmodule.GenerationCSGOrBuilder getValDCSGOrBuilder() {
    return valDCSG_ == null ? openfmb.generationmodule.GenerationCSG.getDefaultInstance() : valDCSG_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (valDCSG_ != null) {
      output.writeMessage(1, getValDCSG());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (valDCSG_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getValDCSG());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.generationmodule.GenerationControlScheduleFSCH)) {
      return super.equals(obj);
    }
    openfmb.generationmodule.GenerationControlScheduleFSCH other = (openfmb.generationmodule.GenerationControlScheduleFSCH) obj;

    if (hasValDCSG() != other.hasValDCSG()) return false;
    if (hasValDCSG()) {
      if (!getValDCSG()
          .equals(other.getValDCSG())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasValDCSG()) {
      hash = (37 * hash) + VALDCSG_FIELD_NUMBER;
      hash = (53 * hash) + getValDCSG().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.generationmodule.GenerationControlScheduleFSCH parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.generationmodule.GenerationControlScheduleFSCH prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * OpenFMB specialization for control schedule using:  LN: Schedule   Name: FSCH
   * </pre>
   *
   * Protobuf type {@code generationmodule.GenerationControlScheduleFSCH}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:generationmodule.GenerationControlScheduleFSCH)
      openfmb.generationmodule.GenerationControlScheduleFSCHOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlScheduleFSCH_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlScheduleFSCH_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.generationmodule.GenerationControlScheduleFSCH.class, openfmb.generationmodule.GenerationControlScheduleFSCH.Builder.class);
    }

    // Construct using openfmb.generationmodule.GenerationControlScheduleFSCH.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      valDCSG_ = null;
      if (valDCSGBuilder_ != null) {
        valDCSGBuilder_.dispose();
        valDCSGBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.generationmodule.Generationmodule.internal_static_generationmodule_GenerationControlScheduleFSCH_descriptor;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlScheduleFSCH getDefaultInstanceForType() {
      return openfmb.generationmodule.GenerationControlScheduleFSCH.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlScheduleFSCH build() {
      openfmb.generationmodule.GenerationControlScheduleFSCH result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.generationmodule.GenerationControlScheduleFSCH buildPartial() {
      openfmb.generationmodule.GenerationControlScheduleFSCH result = new openfmb.generationmodule.GenerationControlScheduleFSCH(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.generationmodule.GenerationControlScheduleFSCH result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.valDCSG_ = valDCSGBuilder_ == null
            ? valDCSG_
            : valDCSGBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.generationmodule.GenerationControlScheduleFSCH) {
        return mergeFrom((openfmb.generationmodule.GenerationControlScheduleFSCH)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.generationmodule.GenerationControlScheduleFSCH other) {
      if (other == openfmb.generationmodule.GenerationControlScheduleFSCH.getDefaultInstance()) return this;
      if (other.hasValDCSG()) {
        mergeValDCSG(other.getValDCSG());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getValDCSGFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.generationmodule.GenerationCSG valDCSG_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationCSG, openfmb.generationmodule.GenerationCSG.Builder, openfmb.generationmodule.GenerationCSGOrBuilder> valDCSGBuilder_;
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the valDCSG field is set.
     */
    public boolean hasValDCSG() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The valDCSG.
     */
    public openfmb.generationmodule.GenerationCSG getValDCSG() {
      if (valDCSGBuilder_ == null) {
        return valDCSG_ == null ? openfmb.generationmodule.GenerationCSG.getDefaultInstance() : valDCSG_;
      } else {
        return valDCSGBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setValDCSG(openfmb.generationmodule.GenerationCSG value) {
      if (valDCSGBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        valDCSG_ = value;
      } else {
        valDCSGBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setValDCSG(
        openfmb.generationmodule.GenerationCSG.Builder builderForValue) {
      if (valDCSGBuilder_ == null) {
        valDCSG_ = builderForValue.build();
      } else {
        valDCSGBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeValDCSG(openfmb.generationmodule.GenerationCSG value) {
      if (valDCSGBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          valDCSG_ != null &&
          valDCSG_ != openfmb.generationmodule.GenerationCSG.getDefaultInstance()) {
          getValDCSGBuilder().mergeFrom(value);
        } else {
          valDCSG_ = value;
        }
      } else {
        valDCSGBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearValDCSG() {
      bitField0_ = (bitField0_ & ~0x00000001);
      valDCSG_ = null;
      if (valDCSGBuilder_ != null) {
        valDCSGBuilder_.dispose();
        valDCSGBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationCSG.Builder getValDCSGBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getValDCSGFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.generationmodule.GenerationCSGOrBuilder getValDCSGOrBuilder() {
      if (valDCSGBuilder_ != null) {
        return valDCSGBuilder_.getMessageOrBuilder();
      } else {
        return valDCSG_ == null ?
            openfmb.generationmodule.GenerationCSG.getDefaultInstance() : valDCSG_;
      }
    }
    /**
     * <pre>
     * Discrete value in GenerationCSG type
     * </pre>
     *
     * <code>.generationmodule.GenerationCSG ValDCSG = 1 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.generationmodule.GenerationCSG, openfmb.generationmodule.GenerationCSG.Builder, openfmb.generationmodule.GenerationCSGOrBuilder> 
        getValDCSGFieldBuilder() {
      if (valDCSGBuilder_ == null) {
        valDCSGBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.generationmodule.GenerationCSG, openfmb.generationmodule.GenerationCSG.Builder, openfmb.generationmodule.GenerationCSGOrBuilder>(
                getValDCSG(),
                getParentForChildren(),
                isClean());
        valDCSG_ = null;
      }
      return valDCSGBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:generationmodule.GenerationControlScheduleFSCH)
  }

  // @@protoc_insertion_point(class_scope:generationmodule.GenerationControlScheduleFSCH)
  private static final openfmb.generationmodule.GenerationControlScheduleFSCH DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.generationmodule.GenerationControlScheduleFSCH();
  }

  public static openfmb.generationmodule.GenerationControlScheduleFSCH getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GenerationControlScheduleFSCH>
      PARSER = new com.google.protobuf.AbstractParser<GenerationControlScheduleFSCH>() {
    @java.lang.Override
    public GenerationControlScheduleFSCH parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<GenerationControlScheduleFSCH> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GenerationControlScheduleFSCH> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.generationmodule.GenerationControlScheduleFSCH getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

